'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var Picker = require('emoji-picker-react');
var axios = require('axios');
var parse = require('html-react-parser');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var Picker__default = /*#__PURE__*/_interopDefaultLegacy(Picker);
var axios__default = /*#__PURE__*/_interopDefaultLegacy(axios);
var parse__default = /*#__PURE__*/_interopDefaultLegacy(parse);

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);

    if (enumerableOnly) {
      symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    }

    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z$8 = ".Chat_Box_Media {\r\n  flex: 0;\r\n  position: relative;\r\n}\r\n#media,\r\n#Media {\r\n  box-shadow: 4px 4px 25px rgba(42, 139, 242, 0.15),\r\n    2px 2px 25px rgba(42, 139, 242, 0.05), 4px 6px 10px rgba(42, 139, 242, 0.15);\r\n  width: 30px;\r\n  height: 30px;\r\n  margin-left: 1%;\r\n  display: flex;\r\n  justify-content: center;\r\n  cursor: pointer;\r\n  align-items: center;\r\n  border-radius: 50%;\r\n}\r\n#Media {\r\n  margin-top: 10%;\r\n}\r\n#media {\r\n  z-index: 1;\r\n  top: 0;\r\n}\r\n#Media {\r\n  visibility: hidden;\r\n  opacity: 0;\r\n}\r\n.Chat_Box_Media > div {\r\n  position: absolute;\r\n  cursor: pointer;\r\n}\r\n";
styleInject(css_248z$8);

var view_media = function view_media(open, setopen) {
  // const $media=document.getElementById('media')
  setopen(function (prev) {
    return !prev;
  });
  var $Media = document.querySelectorAll('#Media'); // const $gallery=document.getElementById('gallery')
  // const $document=document.getElementById('document')

  if (open) {
    $Media.forEach(function (each) {
      each.style.visibility = "visible";
      each.style.opacity = "1";
    });
  } else {
    $Media.forEach(function (each) {
      each.style.visibility = "hidden";
      each.style.opacity = "0";
    });
  }
};
var recognition$1 = window.webkitSpeechRecognition;
var speech$1 = new recognition$1();
speech$1.continuous = true;
var OnMic = function OnMic(On, seton, content, setcontent) {
  document.getElementById('React_textarea').focus();
  var con = content.Message;

  speech$1.onresult = function (e) {
    var current = e.resultIndex;
    var transcript = e.results[current][0].transcript;
    con += transcript;
    setcontent(_objectSpread2(_objectSpread2({}, content), {}, {
      Message: con
    }));
    console.log(con);
  };

  seton(function (prev) {
    return !prev;
  });

  if (On) {
    document.querySelector('.pulse-ring').style.display = 'block';

    if (recognition$1) {
      speech$1.start();
    } else alert('Browser Not supported!!');
  } else {
    document.querySelector('.pulse-ring').style.display = 'none';
    speech$1.stop();
  }
};
var openEmoji = function openEmoji(open, setopen, position) {
  document.getElementById('React_textarea').focus();
  setopen(function (prev) {
    return !prev;
  });

  if (open) {
    document.querySelector(".Picker_".concat(position)).children[0].style.display = "flex";
  } else {
    document.querySelector(".Picker_".concat(position)).children[0].style.display = "none";
  }
};

var Paperclip = function Paperclip(_ref) {
  var theme = _ref.theme,
      width = _ref.width,
      height = _ref.height;
  return /*#__PURE__*/React__default["default"].createElement("svg", {
    width: width,
    height: height,
    viewBox: "0 0 26 19",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/React__default["default"].createElement("path", {
    d: "M23.4739 2.12348C22.6501 1.45812 21.6922 0.940854 20.6194 0.58938C19.5848 0.25117 18.4928 0.0765381 17.3707 0.0765381C16.2514 0.0765381 15.1566 0.246749 14.1221 0.582748C13.052 0.932011 12.0914 1.44264 11.2676 2.10359L2.00063 9.57296C1.34926 10.0946 0.845684 10.7025 0.500842 11.3834C0.169684 12.0399 0 12.734 0 13.448C0 14.1576 0.166947 14.8495 0.495368 15.506C0.834737 16.1846 1.33558 16.7925 1.98147 17.3164C2.62737 17.8403 3.38274 18.2448 4.22295 18.5211C5.03579 18.7886 5.89516 18.9235 6.77642 18.9235C7.65768 18.9235 8.51705 18.7886 9.32989 18.5234C10.1728 18.247 10.9282 17.8425 11.5768 17.3208L18.9417 11.3966C19.4152 11.0164 19.7792 10.5721 20.0282 10.0769C20.2691 9.59946 20.3895 9.09325 20.3895 8.57601C20.3895 7.51054 19.8749 6.5158 18.9417 5.76864C18.0112 5.01264 16.7741 4.59485 15.4577 4.59043C14.1386 4.58822 12.8987 5.00159 11.9655 5.75538L7.37853 9.46243C7.14589 9.65032 7.02 9.8979 7.02 10.161C7.02 10.424 7.14589 10.6738 7.37853 10.8595L7.39768 10.875C7.87389 11.2618 8.65116 11.2618 9.13011 10.8772L13.728 7.17456C14.6886 6.40529 16.2486 6.40087 17.2092 7.16574C17.6718 7.53711 17.9236 8.03447 17.9236 8.56719C17.9236 9.10435 17.6663 9.60837 17.1983 9.98416L9.83621 15.9084C9.82253 15.9194 9.81158 15.9282 9.80337 15.9415C8.99053 16.5803 7.91768 16.9296 6.77916 16.9252C5.63242 16.9208 4.55684 16.5605 3.75221 15.9084C3.34989 15.5768 3.03789 15.1899 2.82168 14.7589C2.61368 14.3411 2.50968 13.899 2.50968 13.448C2.50968 12.524 2.95032 11.6597 3.75221 11.0098C3.76316 11.0032 3.77137 10.9965 3.78232 10.9899L13.0301 3.52277C13.0383 3.51614 13.0465 3.5073 13.0547 3.49845C13.6404 3.03424 14.3219 2.67172 15.08 2.42635C15.8189 2.18761 16.5962 2.06824 17.3954 2.06824C18.1945 2.06824 18.9745 2.19203 19.7107 2.43077C20.4743 2.68056 21.1585 3.0453 21.7442 3.51614C22.3299 3.98919 22.7815 4.54182 23.0907 5.15856C23.3891 5.75319 23.5396 6.38319 23.5396 7.02866C23.5396 7.67635 23.3891 8.30856 23.088 8.90761C22.7787 9.52656 22.3217 10.0836 21.7333 10.5611L15.3427 15.7072C15.1101 15.8951 14.9815 16.1427 14.9815 16.4079C14.9815 16.6732 15.1101 16.9208 15.34 17.1064L15.3537 17.1175C15.8299 17.5021 16.6072 17.5021 17.0834 17.1175L23.4684 11.9736C24.2922 11.3082 24.9326 10.5323 25.3678 9.66801C25.7893 8.83243 26 7.95043 26 7.04411C26 6.14001 25.7865 5.25801 25.3678 4.42464C24.9354 3.56033 24.2977 2.78664 23.4739 2.12348Z",
    fill: theme
  }));
};
var Document = function Document(_ref2) {
  var theme = _ref2.theme,
      width = _ref2.width,
      height = _ref2.height;
  return /*#__PURE__*/React__default["default"].createElement("svg", {
    width: width,
    height: height,
    viewBox: "0 0 24 24",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/React__default["default"].createElement("path", {
    "fill-rule": "evenodd",
    "clip-rule": "evenodd",
    d: "M17.4443 20H6.5553C6.2493 20 6.0003 19.776 6.0003 19.5V4.5C6.0003 4.224 6.2493 4 6.5553 4H11.0003V8.15C11.0003 9.722 12.2173 11 13.7143 11H18.0003V19.5C18.0003 19.776 17.7503 20 17.4443 20ZM17.6493 9H13.7143C13.3203 9 13.0003 8.619 13.0003 8.15V4H13.1123L17.6493 9ZM19.7403 8.328L14.2963 2.328C14.1073 2.119 13.8383 2 13.5553 2H6.5553C5.1463 2 4.0003 3.122 4.0003 4.5V19.5C4.0003 20.878 5.1463 22 6.5553 22H17.4443C18.8533 22 20.0003 20.878 20.0003 19.5V9C20.0003 8.751 19.9073 8.512 19.7403 8.328Z",
    fill: "white"
  }), /*#__PURE__*/React__default["default"].createElement("mask", {
    id: "mask0",
    "mask-type": "alpha",
    maskUnits: "userSpaceOnUse",
    x: "4",
    y: "2",
    width: "17",
    height: "20"
  }, /*#__PURE__*/React__default["default"].createElement("path", {
    "fill-rule": "evenodd",
    "clip-rule": "evenodd",
    d: "M17.4443 20H6.5553C6.2493 20 6.0003 19.776 6.0003 19.5V4.5C6.0003 4.224 6.2493 4 6.5553 4H11.0003V8.15C11.0003 9.722 12.2173 11 13.7143 11H18.0003V19.5C18.0003 19.776 17.7503 20 17.4443 20ZM17.6493 9H13.7143C13.3203 9 13.0003 8.619 13.0003 8.15V4H13.1123L17.6493 9ZM19.7403 8.328L14.2963 2.328C14.1073 2.119 13.8383 2 13.5553 2H6.5553C5.1463 2 4.0003 3.122 4.0003 4.5V19.5C4.0003 20.878 5.1463 22 6.5553 22H17.4443C18.8533 22 20.0003 20.878 20.0003 19.5V9C20.0003 8.751 19.9073 8.512 19.7403 8.328Z",
    fill: "white"
  })), /*#__PURE__*/React__default["default"].createElement("g", {
    mask: "url(#mask0)"
  }, /*#__PURE__*/React__default["default"].createElement("rect", {
    width: "24",
    height: "24",
    fill: theme
  })));
};
var Audio = function Audio(_ref3) {
  var theme = _ref3.theme,
      width = _ref3.width,
      height = _ref3.height;
  return /*#__PURE__*/React__default["default"].createElement("svg", {
    width: width,
    height: height,
    viewBox: "0 0 156 266",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/React__default["default"].createElement("path", {
    d: "M155.153 194.881C158.256 208.799 152.042 225.811 140.006 234.682C126.743 244.449 111.477 240.606 105.915 226.099C100.348 211.593 106.59 191.915 119.85 182.153C126.619 177.168 133.906 175.747 140.159 177.459L139.858 25.2654L51.3672 46.6802L51.3543 220.913C54.4018 234.81 48.1882 251.76 36.1807 260.598C22.9182 270.36 7.65581 266.53 2.08981 252.023C-3.47397 237.509 2.7646 217.831 16.0271 208.065C22.8044 203.072 30.0987 201.651 36.3609 203.379L36.3805 28.8226L155.538 0L155.153 194.881Z",
    fill: theme
  }));
};
var Photo = function Photo(_ref4) {
  var theme = _ref4.theme,
      width = _ref4.width,
      height = _ref4.height;
  return /*#__PURE__*/React__default["default"].createElement("svg", {
    width: width,
    height: height,
    viewBox: "0 0 12 11",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/React__default["default"].createElement("g", {
    "clip-path": "url(#clip0)"
  }, /*#__PURE__*/React__default["default"].createElement("path", {
    d: "M8.08802 9.86258H1.13454C0.725977 9.86258 0.393586 9.55789 0.393586 9.18335V1.81673C0.393586 1.44219 0.725977 1.1375 1.13454 1.1375H2.46134C2.57004 1.1375 2.65812 1.05674 2.65812 0.957116C2.65812 0.857493 2.57004 0.776733 2.46134 0.776733H1.13454C0.508945 0.776733 0 1.24329 0 1.81673V9.18335C0 9.75684 0.508945 10.2234 1.13454 10.2234H8.08805C8.19675 10.2234 8.28483 10.1426 8.28483 10.043C8.28483 9.94336 8.19673 9.86258 8.08802 9.86258Z",
    fill: theme
  }), /*#__PURE__*/React__default["default"].createElement("path", {
    d: "M10.8655 0.776733H3.18811C3.0794 0.776733 2.99133 0.857493 2.99133 0.957116C2.99133 1.05674 3.0794 1.13752 3.18811 1.13752H10.8655C11.274 1.13752 11.6064 1.44221 11.6064 1.81675V9.18338C11.6064 9.55791 11.274 9.86261 10.8655 9.86261H8.87519C8.76649 9.86261 8.67841 9.94337 8.67841 10.043C8.67841 10.1426 8.76649 10.2234 8.87519 10.2234H10.8655C11.4911 10.2234 12 9.75684 12 9.18336V1.81675C12 1.24331 11.491 0.776733 10.8655 0.776733Z",
    fill: theme
  }), /*#__PURE__*/React__default["default"].createElement("path", {
    d: "M10.3244 1.58533H1.67564C1.23811 1.58533 0.882188 1.91159 0.882188 2.31266V3.47432C0.882117 3.47675 0.882164 3.47915 0.882188 3.48158V8.68725C0.882188 9.08748 1.23666 9.41316 1.67292 9.41454C1.67381 9.41454 1.67473 9.41467 1.67564 9.41467C1.67588 9.41467 1.67609 9.41462 1.67632 9.41462H4.58081C4.58109 9.41462 4.5814 9.41467 4.58166 9.41467C4.58166 9.41467 4.58208 9.41462 4.58229 9.41462H10.3244C10.7619 9.4146 11.1178 9.08834 11.1178 8.68727V5.0274C11.1178 5.02732 11.1178 5.02721 11.1178 5.02713V2.31266C11.1178 1.91159 10.7619 1.58533 10.3244 1.58533ZM1.54988 9.03495C1.39088 8.98646 1.2758 8.84905 1.2758 8.68725V7.36972C1.70025 6.94491 2.22865 6.71788 2.84815 6.69586C3.03834 6.68907 3.21005 6.70353 3.34931 6.72379C2.55281 7.36671 1.90692 8.23797 1.54988 9.03495ZM1.27577 3.57237C1.4457 3.47017 1.64175 3.41653 1.84812 3.41653C2.30009 3.41653 2.69948 3.68061 2.84198 4.07373C2.86069 4.12538 2.90384 4.1665 2.95943 4.18567C3.01495 4.20481 3.07702 4.2 3.12825 4.1725C3.30314 4.07855 3.50297 4.0289 3.70615 4.0289C4.28452 4.0289 4.77316 4.4253 4.84273 4.95096C4.85374 5.03428 4.92602 5.09963 5.01708 5.10859C5.42559 5.14883 5.76096 5.41853 5.8717 5.76915C5.55012 5.75102 5.21848 5.79016 4.88288 5.88788C4.48652 6.00327 4.10285 6.19334 3.74271 6.43401C3.5831 6.39173 3.25505 6.32265 2.84988 6.33484C2.41758 6.34786 1.82632 6.45889 1.2758 6.87306V3.57237H1.27577ZM10.7242 8.68725C10.7242 8.88935 10.5448 9.05379 10.3244 9.05379H4.90254C5.01867 8.86168 5.15119 8.67431 5.28101 8.49144C5.36848 8.36818 5.45897 8.24069 5.54379 8.11267C5.60018 8.0275 5.57058 7.91654 5.4777 7.86483C5.38481 7.81316 5.26378 7.84025 5.20732 7.92541C5.12571 8.04865 5.03693 8.17373 4.95108 8.29468C4.779 8.53714 4.60191 8.78691 4.45767 9.05381H1.96807C2.66494 7.57732 3.99427 6.5251 5.00196 6.23171C5.60391 6.05646 6.16913 6.09518 6.6858 6.34633C6.64805 6.37828 6.61043 6.41057 6.57298 6.4434C6.32119 6.66413 6.07249 6.90866 5.8338 7.17026C5.80662 7.20006 5.77962 7.22998 5.75281 7.26006C5.68406 7.33721 5.69656 7.45086 5.7807 7.51388C5.86231 7.575 5.98941 7.56484 6.05761 7.48831C6.08344 7.45933 6.10943 7.4305 6.13568 7.40175C6.36506 7.15036 6.6037 6.91567 6.84499 6.70417C7.1186 6.46432 7.40116 6.24948 7.68483 6.06551C7.99805 5.86242 8.31991 5.69217 8.64155 5.55949C8.99423 5.41402 9.35566 5.30997 9.71573 5.25028C10.0475 5.19528 10.3859 5.177 10.7242 5.19496V8.68725H10.7242ZM10.7242 4.83385C10.3624 4.81626 10.0006 4.83643 9.64568 4.89525C9.25409 4.96018 8.86193 5.07297 8.48006 5.2305C8.13537 5.37266 7.79135 5.55452 7.45753 5.771C7.30385 5.87064 7.15066 5.97888 6.99907 6.0946C6.77201 5.96954 6.53377 5.87999 6.28753 5.82596C6.19931 5.30855 5.76595 4.88516 5.20821 4.77223C5.05416 4.13402 4.43285 3.66813 3.7061 3.66813C3.50766 3.66813 3.31153 3.70341 3.12891 3.77117C2.8849 3.33624 2.3944 3.05576 1.84809 3.05576C1.6477 3.05576 1.45441 3.09267 1.27575 3.16378V2.31268H1.27577C1.27577 2.11058 1.45516 1.94614 1.67564 1.94614H10.3243C10.5448 1.94614 10.7242 2.11058 10.7242 2.31268V4.83385H10.7242Z",
    fill: theme
  }), /*#__PURE__*/React__default["default"].createElement("path", {
    d: "M7.98375 2.8429C7.41089 2.8429 6.94481 3.27013 6.94481 3.79525C6.94481 4.32038 7.41089 4.74761 7.98375 4.74761C8.55661 4.74761 9.02269 4.32038 9.02269 3.79525C9.02271 3.27013 8.55663 2.8429 7.98375 2.8429ZM7.98375 4.38687C7.62788 4.38687 7.33838 4.12147 7.33838 3.79528C7.3384 3.46906 7.6279 3.20368 7.98375 3.20368C8.33963 3.20368 8.62912 3.46906 8.62912 3.79528C8.62912 4.12147 8.33963 4.38687 7.98375 4.38687Z",
    fill: theme
  })), /*#__PURE__*/React__default["default"].createElement("defs", null, /*#__PURE__*/React__default["default"].createElement("clipPath", {
    id: "clip0"
  }, /*#__PURE__*/React__default["default"].createElement("rect", {
    width: "12",
    height: "11",
    fill: theme
  }))));
};
var Emoji = function Emoji(_ref5) {
  var theme = _ref5.theme,
      width = _ref5.width,
      height = _ref5.height;
  return /*#__PURE__*/React__default["default"].createElement("svg", {
    width: width,
    height: height,
    viewBox: "0 0 48 42",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/React__default["default"].createElement("path", {
    d: "M24 0C10.7664 0 0 9.4206 0 21C0 32.5794 10.7664 42 24 42C37.2336 42 48 32.5794 48 21C48 9.4206 37.2336 0 24 0ZM24 38.1818C13.1725 38.1818 4.36364 30.4741 4.36364 21C4.36364 11.5259 13.1725 3.81818 24 3.81818C34.8275 3.81818 43.6364 11.5259 43.6364 21C43.6364 30.4741 34.8275 38.1818 24 38.1818Z",
    fill: theme
  }), /*#__PURE__*/React__default["default"].createElement("path", {
    d: "M29.8627 26.1298C26.6298 28.9583 21.3702 28.9584 18.1375 26.1299C17.2855 25.3844 15.904 25.3844 15.0519 26.1299C14.1999 26.8755 14.1999 28.0842 15.0519 28.8297C17.5193 30.9887 20.759 32.0677 24.0002 32.0677C27.2403 32.0677 30.4816 30.9882 32.9484 28.8297C33.8005 28.0843 33.8005 26.8755 32.9484 26.1299C32.0962 25.3842 30.7146 25.3844 29.8627 26.1298Z",
    fill: theme
  }), /*#__PURE__*/React__default["default"].createElement("path", {
    d: "M16.7476 18.7269C17.2902 18.2535 17.6 17.5967 17.6 16.9273C17.6 16.2578 17.2902 15.6011 16.7476 15.1277C16.2066 14.6542 15.456 14.3818 14.6909 14.3818C13.9242 14.3818 13.1753 14.6542 12.634 15.1277C12.0916 15.6011 11.7818 16.2578 11.7818 16.9273C11.7818 17.5967 12.0916 18.2535 12.634 18.7269C13.1753 19.2017 13.9258 19.4727 14.6909 19.4727C15.456 19.4727 16.2066 19.2017 16.7476 18.7269Z",
    fill: theme
  }), /*#__PURE__*/React__default["default"].createElement("path", {
    d: "M33.3091 14.3818C32.544 14.3818 31.7934 14.6542 31.2522 15.1277C30.7113 15.6011 30.4 16.2566 30.4 16.9273C30.4 17.598 30.7113 18.2535 31.2522 18.7269C31.7934 19.2017 32.544 19.4727 33.3091 19.4727C34.0742 19.4727 34.8247 19.2017 35.3658 18.7269C35.9069 18.2535 36.2182 17.598 36.2182 16.9273C36.2182 16.2578 35.9068 15.6011 35.3658 15.1277C34.8247 14.6542 34.0742 14.3818 33.3091 14.3818Z",
    fill: theme
  }));
};
var SendSvg = function SendSvg(_ref6) {
  var theme = _ref6.theme,
      width = _ref6.width,
      height = _ref6.height;
  return /*#__PURE__*/React__default["default"].createElement("svg", {
    width: width,
    height: height,
    viewBox: "0 0 23 16",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/React__default["default"].createElement("path", {
    d: "M21.7389 7.04552L3.00827 1.02232C1.39032 0.502021 -0.35512 1.54424 0.0627886 2.78044L1.03279 5.64973C1.17038 6.05665 1.53964 6.40935 2.04595 6.61735L5.80524 8.16208C6.10725 8.2862 6.10792 8.59878 5.80524 8.72319L2.046 10.2679C1.53968 10.4759 1.17043 10.8287 1.03283 11.2356L0.0627886 14.1048C-0.354221 15.3382 1.38825 16.3838 3.00827 15.8629L21.7389 9.83976C23.4215 9.29869 23.4192 7.58584 21.7389 7.04552ZM16.139 8.99368L9.51215 11.1247C9.08808 11.261 8.59031 11.125 8.40024 10.8205C8.21018 10.5162 8.39997 10.1589 8.82403 10.0225L13.7371 8.44262L8.82403 6.86272C8.39997 6.72632 8.21018 6.36905 8.40024 6.06474C8.59022 5.76041 9.08795 5.62417 9.51215 5.76057L16.139 7.89159C16.8006 8.10427 16.8011 8.7808 16.139 8.99368Z",
    fill: theme
  }));
};
var Microphone = function Microphone(_ref7) {
  var width = _ref7.width,
      height = _ref7.height,
      theme = _ref7.theme;
  return /*#__PURE__*/React__default["default"].createElement("svg", {
    width: width,
    height: height,
    viewBox: "0 0 32 32",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/React__default["default"].createElement("path", {
    d: "M16 20.5819C19.2121 20.5819 21.816 17.9779 21.816 14.7658V5.81603C21.816 2.60391 19.2121 0 16 0C12.788 0 10.184 2.60391 10.184 5.81603V14.7659C10.184 17.9779 12.788 20.5819 16 20.5819Z",
    fill: theme
  }), /*#__PURE__*/React__default["default"].createElement("path", {
    d: "M23.8586 9.2696V11.3122H24.8799V14.7658C24.8799 19.6622 20.8963 23.6457 16 23.6457C11.1037 23.6457 7.12014 19.6622 7.12014 14.7658V11.3122H8.14142V9.2696H5.07759V14.7658C5.07759 20.4441 9.43327 25.1234 14.9787 25.6401V29.9574H8.82084V31.9999H23.1792V29.9574H17.0213V25.6401C22.5667 25.1234 26.9224 20.444 26.9224 14.7658V9.26953H23.8586V9.2696Z",
    fill: theme
  }));
};
var Search = function Search(_ref8) {
  var width = _ref8.width,
      height = _ref8.height,
      theme = _ref8.theme;
  return /*#__PURE__*/React__default["default"].createElement("svg", {
    width: width,
    height: height,
    viewBox: "0 0 104 124",
    fill: "none",
    xmlns: "http://www.w3.org/2000/svg"
  }, /*#__PURE__*/React__default["default"].createElement("path", {
    d: "M102.689 115.118L72.8501 79.5155C78.7327 71.104 82.2707 60.3545 82.2707 48.614C82.2707 21.8292 63.8344 0.0507812 41.1567 0.0507812C18.4789 0.0507812 0 21.8547 0 48.6394C0 75.4241 18.4363 97.2025 41.114 97.2025C50.7478 97.2025 59.6143 93.2636 66.6478 86.6818L96.5935 122.386C98.3412 124.47 100.941 124.47 102.689 122.386C104.437 120.302 104.437 117.202 102.689 115.118ZM8.7386 48.6394C8.7386 27.5979 23.2745 10.4953 41.114 10.4953C58.9536 10.4953 73.4895 27.5979 73.4895 48.6394C73.4895 69.6809 58.9536 86.7834 41.114 86.7834C23.2745 86.7834 8.7386 69.6555 8.7386 48.6394Z",
    fill: theme
  }));
};

var openFile = function openFile(allow, data, setdata, setopen) {
  var input = document.createElement('input');
  input.type = 'file';
  input.accept = allow;

  input.onchange = function (e) {
    var file = e.target.files[0];
    var reader = new FileReader();
    reader.readAsDataURL(file);

    reader.onload = function (read) {
      setopen();
      document.getElementById('React_textarea').focus();
      var content = read.target.result;

      if (allow.includes('.pdf')) {
        setdata(_objectSpread2(_objectSpread2({}, data), {}, {
          Media: _objectSpread2(_objectSpread2({}, data.Media), {}, {
            doc: content
          })
        }));
      } else if (allow.includes('image/jpeg')) {
        setdata(_objectSpread2(_objectSpread2({}, data), {}, {
          Media: _objectSpread2(_objectSpread2({}, data.Media), {}, {
            Image: content
          })
        }));
      } else {
        setdata(_objectSpread2(_objectSpread2({}, data), {}, {
          Media: _objectSpread2(_objectSpread2({}, data.Media), {}, {
            audio: content
          })
        }));
      }
    };

    reader.onerror = function (e) {
      setopen();
      console.log(e);
    };
  };

  input.click();
};

function Media(_ref) {
  var data = _ref.data,
      setdata = _ref.setdata,
      Types = _ref.Types,
      background = _ref.background,
      theme = _ref.theme,
      media = _ref.media;

  var _useState = React.useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      openview = _useState2[0],
      setopenview = _useState2[1];

  var openmedia = function openmedia() {
    view_media(openview, setopenview);
  };

  var MediaTypes = Types.map(function (each, index) {
    var files = {
      Image: "image/jpeg,image/jpg,image/png",
      Doc: ".pdf,.doc,application/ms-word,.docx",
      audio: ".mp3"
    };
    return /*#__PURE__*/React__default["default"].createElement("div", {
      id: "Media",
      key: index,
      style: {
        transform: "translateY(-".concat((index + 1) * 32, "px)"),
        transition: "0.".concat(index + 2, "s all"),
        background: background
      },
      onClick: function onClick() {
        return openFile(each === 'Document' ? files.Doc : each === "Gallery" ? files.Image : files.audio, data, setdata, openmedia);
      }
    }, each === 'Document' ? /*#__PURE__*/React__default["default"].createElement(Document, {
      theme: theme === 'dark' ? "black" : "white",
      width: "15",
      height: "15"
    }) : each === "Gallery" ? /*#__PURE__*/React__default["default"].createElement(Photo, {
      theme: theme === 'dark' ? "black" : "white",
      width: "15",
      height: "15"
    }) : /*#__PURE__*/React__default["default"].createElement(Audio, {
      theme: theme === 'dark' ? "black" : "white",
      width: "15",
      height: "15"
    }));
  });
  return /*#__PURE__*/React__default["default"].createElement("div", {
    style: media ? null : {
      display: "none"
    },
    className: "Chat_Box_Media"
  }, /*#__PURE__*/React__default["default"].createElement("div", {
    id: "media",
    style: {
      background: background
    },
    onClick: function onClick() {
      return openmedia();
    }
  }, " ", /*#__PURE__*/React__default["default"].createElement(Paperclip, {
    theme: theme === 'dark' ? "black" : "white",
    width: "15",
    height: "15"
  })), MediaTypes);
}

var css_248z$7 = ".Chat_Box_Input > textarea {\r\n  width: 100%;\r\n}\r\n.Chat_Box_Input {\r\n  margin-left: 40px;\r\n}\r\n.Chat_Box_Input > textarea {\r\n  border: 0;\r\n  background: transparent;\r\n  scrollbar-width: none;\r\n  font-size: 0.825em;\r\n  letter-spacing: 0.01em;\r\n  font-family: Arial, Helvetica, sans-serif;\r\n  resize: none;\r\n}\r\n.Chat_Box_Input > textarea::-webkit-scrollbar {\r\n  width: 0 !important;\r\n}\r\n.Chat_Box_Input > textarea:focus {\r\n  outline: none;\r\n}\r\n.Chat_Box_Input {\r\n  flex: 2;\r\n}\r\n";
styleInject(css_248z$7);

function Input$1(_ref) {
  var data = _ref.data,
      setdata = _ref.setdata,
      placeholder = _ref.placeholder,
      media = _ref.media;

  var handlechange = function handlechange(event) {
    setdata(_objectSpread2(_objectSpread2({}, data), {}, {
      Message: event.target.value
    }));
  };

  return /*#__PURE__*/React__default["default"].createElement("div", {
    style: media ? null : {
      marginLeft: "5px"
    },
    className: "Chat_Box_Input"
  }, /*#__PURE__*/React__default["default"].createElement("textarea", {
    id: "React_textarea",
    onChange: handlechange,
    value: data.Message,
    placeholder: placeholder
  }));
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

/** @license React v16.13.1
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?
Symbol.for("react.suspense_list"):60120,r=b?Symbol.for("react.memo"):60115,t=b?Symbol.for("react.lazy"):60116,v=b?Symbol.for("react.block"):60121,w=b?Symbol.for("react.fundamental"):60117,x=b?Symbol.for("react.responder"):60118,y=b?Symbol.for("react.scope"):60119;
function z(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case t:case r:case h:return a;default:return u}}case d:return u}}}function A(a){return z(a)===m}var AsyncMode=l;var ConcurrentMode=m;var ContextConsumer=k;var ContextProvider=h;var Element=c;var ForwardRef=n;var Fragment=e;var Lazy=t;var Memo=r;var Portal=d;
var Profiler=g;var StrictMode=f;var Suspense=p;var isAsyncMode=function(a){return A(a)||z(a)===l};var isConcurrentMode=A;var isContextConsumer=function(a){return z(a)===k};var isContextProvider=function(a){return z(a)===h};var isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};var isForwardRef=function(a){return z(a)===n};var isFragment=function(a){return z(a)===e};var isLazy=function(a){return z(a)===t};
var isMemo=function(a){return z(a)===r};var isPortal=function(a){return z(a)===d};var isProfiler=function(a){return z(a)===g};var isStrictMode=function(a){return z(a)===f};var isSuspense=function(a){return z(a)===p};
var isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||a===q||"object"===typeof a&&null!==a&&(a.$$typeof===t||a.$$typeof===r||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n||a.$$typeof===w||a.$$typeof===x||a.$$typeof===y||a.$$typeof===v)};var typeOf=z;

var reactIs_production_min = {
	AsyncMode: AsyncMode,
	ConcurrentMode: ConcurrentMode,
	ContextConsumer: ContextConsumer,
	ContextProvider: ContextProvider,
	Element: Element,
	ForwardRef: ForwardRef,
	Fragment: Fragment,
	Lazy: Lazy,
	Memo: Memo,
	Portal: Portal,
	Profiler: Profiler,
	StrictMode: StrictMode,
	Suspense: Suspense,
	isAsyncMode: isAsyncMode,
	isConcurrentMode: isConcurrentMode,
	isContextConsumer: isContextConsumer,
	isContextProvider: isContextProvider,
	isElement: isElement,
	isForwardRef: isForwardRef,
	isFragment: isFragment,
	isLazy: isLazy,
	isMemo: isMemo,
	isPortal: isPortal,
	isProfiler: isProfiler,
	isStrictMode: isStrictMode,
	isSuspense: isSuspense,
	isValidElementType: isValidElementType,
	typeOf: typeOf
};

var reactIs_development = createCommonjsModule(function (module, exports) {



if (process.env.NODE_ENV !== "production") {
  (function() {

// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
// nor polyfill, then a plain number is used for performance.
var hasSymbol = typeof Symbol === 'function' && Symbol.for;
var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace; // TODO: We don't use AsyncMode or ConcurrentMode anymore. They were temporary
// (unstable) APIs that have been removed. Can we remove the symbols?

var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for('react.block') : 0xead9;
var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;
var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 0xead7;

function isValidElementType(type) {
  return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
  type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE || type.$$typeof === REACT_BLOCK_TYPE);
}

function typeOf(object) {
  if (typeof object === 'object' && object !== null) {
    var $$typeof = object.$$typeof;

    switch ($$typeof) {
      case REACT_ELEMENT_TYPE:
        var type = object.type;

        switch (type) {
          case REACT_ASYNC_MODE_TYPE:
          case REACT_CONCURRENT_MODE_TYPE:
          case REACT_FRAGMENT_TYPE:
          case REACT_PROFILER_TYPE:
          case REACT_STRICT_MODE_TYPE:
          case REACT_SUSPENSE_TYPE:
            return type;

          default:
            var $$typeofType = type && type.$$typeof;

            switch ($$typeofType) {
              case REACT_CONTEXT_TYPE:
              case REACT_FORWARD_REF_TYPE:
              case REACT_LAZY_TYPE:
              case REACT_MEMO_TYPE:
              case REACT_PROVIDER_TYPE:
                return $$typeofType;

              default:
                return $$typeof;
            }

        }

      case REACT_PORTAL_TYPE:
        return $$typeof;
    }
  }

  return undefined;
} // AsyncMode is deprecated along with isAsyncMode

var AsyncMode = REACT_ASYNC_MODE_TYPE;
var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
var ContextConsumer = REACT_CONTEXT_TYPE;
var ContextProvider = REACT_PROVIDER_TYPE;
var Element = REACT_ELEMENT_TYPE;
var ForwardRef = REACT_FORWARD_REF_TYPE;
var Fragment = REACT_FRAGMENT_TYPE;
var Lazy = REACT_LAZY_TYPE;
var Memo = REACT_MEMO_TYPE;
var Portal = REACT_PORTAL_TYPE;
var Profiler = REACT_PROFILER_TYPE;
var StrictMode = REACT_STRICT_MODE_TYPE;
var Suspense = REACT_SUSPENSE_TYPE;
var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated

function isAsyncMode(object) {
  {
    if (!hasWarnedAboutDeprecatedIsAsyncMode) {
      hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint

      console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
    }
  }

  return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
}
function isConcurrentMode(object) {
  return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
}
function isContextConsumer(object) {
  return typeOf(object) === REACT_CONTEXT_TYPE;
}
function isContextProvider(object) {
  return typeOf(object) === REACT_PROVIDER_TYPE;
}
function isElement(object) {
  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
}
function isForwardRef(object) {
  return typeOf(object) === REACT_FORWARD_REF_TYPE;
}
function isFragment(object) {
  return typeOf(object) === REACT_FRAGMENT_TYPE;
}
function isLazy(object) {
  return typeOf(object) === REACT_LAZY_TYPE;
}
function isMemo(object) {
  return typeOf(object) === REACT_MEMO_TYPE;
}
function isPortal(object) {
  return typeOf(object) === REACT_PORTAL_TYPE;
}
function isProfiler(object) {
  return typeOf(object) === REACT_PROFILER_TYPE;
}
function isStrictMode(object) {
  return typeOf(object) === REACT_STRICT_MODE_TYPE;
}
function isSuspense(object) {
  return typeOf(object) === REACT_SUSPENSE_TYPE;
}

exports.AsyncMode = AsyncMode;
exports.ConcurrentMode = ConcurrentMode;
exports.ContextConsumer = ContextConsumer;
exports.ContextProvider = ContextProvider;
exports.Element = Element;
exports.ForwardRef = ForwardRef;
exports.Fragment = Fragment;
exports.Lazy = Lazy;
exports.Memo = Memo;
exports.Portal = Portal;
exports.Profiler = Profiler;
exports.StrictMode = StrictMode;
exports.Suspense = Suspense;
exports.isAsyncMode = isAsyncMode;
exports.isConcurrentMode = isConcurrentMode;
exports.isContextConsumer = isContextConsumer;
exports.isContextProvider = isContextProvider;
exports.isElement = isElement;
exports.isForwardRef = isForwardRef;
exports.isFragment = isFragment;
exports.isLazy = isLazy;
exports.isMemo = isMemo;
exports.isPortal = isPortal;
exports.isProfiler = isProfiler;
exports.isStrictMode = isStrictMode;
exports.isSuspense = isSuspense;
exports.isValidElementType = isValidElementType;
exports.typeOf = typeOf;
  })();
}
});
reactIs_development.AsyncMode;
reactIs_development.ConcurrentMode;
reactIs_development.ContextConsumer;
reactIs_development.ContextProvider;
reactIs_development.Element;
reactIs_development.ForwardRef;
reactIs_development.Fragment;
reactIs_development.Lazy;
reactIs_development.Memo;
reactIs_development.Portal;
reactIs_development.Profiler;
reactIs_development.StrictMode;
reactIs_development.Suspense;
reactIs_development.isAsyncMode;
reactIs_development.isConcurrentMode;
reactIs_development.isContextConsumer;
reactIs_development.isContextProvider;
reactIs_development.isElement;
reactIs_development.isForwardRef;
reactIs_development.isFragment;
reactIs_development.isLazy;
reactIs_development.isMemo;
reactIs_development.isPortal;
reactIs_development.isProfiler;
reactIs_development.isStrictMode;
reactIs_development.isSuspense;
reactIs_development.isValidElementType;
reactIs_development.typeOf;

var reactIs = createCommonjsModule(function (module) {

if (process.env.NODE_ENV === 'production') {
  module.exports = reactIs_production_min;
} else {
  module.exports = reactIs_development;
}
});

/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
/* eslint-disable no-unused-vars */
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;

function toObject(val) {
	if (val === null || val === undefined) {
		throw new TypeError('Object.assign cannot be called with null or undefined');
	}

	return Object(val);
}

function shouldUseNative() {
	try {
		if (!Object.assign) {
			return false;
		}

		// Detect buggy property enumeration order in older V8 versions.

		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
		test1[5] = 'de';
		if (Object.getOwnPropertyNames(test1)[0] === '5') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test2 = {};
		for (var i = 0; i < 10; i++) {
			test2['_' + String.fromCharCode(i)] = i;
		}
		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
			return test2[n];
		});
		if (order2.join('') !== '0123456789') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test3 = {};
		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
			test3[letter] = letter;
		});
		if (Object.keys(Object.assign({}, test3)).join('') !==
				'abcdefghijklmnopqrst') {
			return false;
		}

		return true;
	} catch (err) {
		// We don't expect any of the above to throw, but better to be safe.
		return false;
	}
}

var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
	var from;
	var to = toObject(target);
	var symbols;

	for (var s = 1; s < arguments.length; s++) {
		from = Object(arguments[s]);

		for (var key in from) {
			if (hasOwnProperty.call(from, key)) {
				to[key] = from[key];
			}
		}

		if (getOwnPropertySymbols) {
			symbols = getOwnPropertySymbols(from);
			for (var i = 0; i < symbols.length; i++) {
				if (propIsEnumerable.call(from, symbols[i])) {
					to[symbols[i]] = from[symbols[i]];
				}
			}
		}
	}

	return to;
};

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var ReactPropTypesSecret$1 = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

var ReactPropTypesSecret_1 = ReactPropTypesSecret$1;

var printWarning$1 = function() {};

if (process.env.NODE_ENV !== 'production') {
  var ReactPropTypesSecret = ReactPropTypesSecret_1;
  var loggedTypeFailures = {};
  var has$1 = Function.call.bind(Object.prototype.hasOwnProperty);

  printWarning$1 = function(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

/**
 * Assert that the values match with the type specs.
 * Error messages are memorized and will only be shown once.
 *
 * @param {object} typeSpecs Map of name to a ReactPropType
 * @param {object} values Runtime values that need to be type-checked
 * @param {string} location e.g. "prop", "context", "child context"
 * @param {string} componentName Name of the component for error messages.
 * @param {?Function} getStack Returns the component stack.
 * @private
 */
function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
  if (process.env.NODE_ENV !== 'production') {
    for (var typeSpecName in typeSpecs) {
      if (has$1(typeSpecs, typeSpecName)) {
        var error;
        // Prop type validation may throw. In case they do, we don't want to
        // fail the render phase where it didn't fail before. So we log it.
        // After these have been cleaned up, we'll let them throw.
        try {
          // This is intentionally an invariant that gets caught. It's the same
          // behavior as without this statement except with a better message.
          if (typeof typeSpecs[typeSpecName] !== 'function') {
            var err = Error(
              (componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' +
              'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.'
            );
            err.name = 'Invariant Violation';
            throw err;
          }
          error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret);
        } catch (ex) {
          error = ex;
        }
        if (error && !(error instanceof Error)) {
          printWarning$1(
            (componentName || 'React class') + ': type specification of ' +
            location + ' `' + typeSpecName + '` is invalid; the type checker ' +
            'function must return `null` or an `Error` but returned a ' + typeof error + '. ' +
            'You may have forgotten to pass an argument to the type checker ' +
            'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' +
            'shape all require an argument).'
          );
        }
        if (error instanceof Error && !(error.message in loggedTypeFailures)) {
          // Only monitor this failure once because there tends to be a lot of the
          // same error.
          loggedTypeFailures[error.message] = true;

          var stack = getStack ? getStack() : '';

          printWarning$1(
            'Failed ' + location + ' type: ' + error.message + (stack != null ? stack : '')
          );
        }
      }
    }
  }
}

/**
 * Resets warning cache when testing.
 *
 * @private
 */
checkPropTypes.resetWarningCache = function() {
  if (process.env.NODE_ENV !== 'production') {
    loggedTypeFailures = {};
  }
};

var checkPropTypes_1 = checkPropTypes;

var has = Function.call.bind(Object.prototype.hasOwnProperty);
var printWarning = function() {};

if (process.env.NODE_ENV !== 'production') {
  printWarning = function(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

function emptyFunctionThatReturnsNull() {
  return null;
}

var factoryWithTypeCheckers = function(isValidElement, throwOnDirectAccess) {
  /* global Symbol */
  var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
  var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

  /**
   * Returns the iterator method function contained on the iterable object.
   *
   * Be sure to invoke the function with the iterable as context:
   *
   *     var iteratorFn = getIteratorFn(myIterable);
   *     if (iteratorFn) {
   *       var iterator = iteratorFn.call(myIterable);
   *       ...
   *     }
   *
   * @param {?object} maybeIterable
   * @return {?function}
   */
  function getIteratorFn(maybeIterable) {
    var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
    if (typeof iteratorFn === 'function') {
      return iteratorFn;
    }
  }

  /**
   * Collection of methods that allow declaration and validation of props that are
   * supplied to React components. Example usage:
   *
   *   var Props = require('ReactPropTypes');
   *   var MyArticle = React.createClass({
   *     propTypes: {
   *       // An optional string prop named "description".
   *       description: Props.string,
   *
   *       // A required enum prop named "category".
   *       category: Props.oneOf(['News','Photos']).isRequired,
   *
   *       // A prop named "dialog" that requires an instance of Dialog.
   *       dialog: Props.instanceOf(Dialog).isRequired
   *     },
   *     render: function() { ... }
   *   });
   *
   * A more formal specification of how these methods are used:
   *
   *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
   *   decl := ReactPropTypes.{type}(.isRequired)?
   *
   * Each and every declaration produces a function with the same signature. This
   * allows the creation of custom validation functions. For example:
   *
   *  var MyLink = React.createClass({
   *    propTypes: {
   *      // An optional string or URI prop named "href".
   *      href: function(props, propName, componentName) {
   *        var propValue = props[propName];
   *        if (propValue != null && typeof propValue !== 'string' &&
   *            !(propValue instanceof URI)) {
   *          return new Error(
   *            'Expected a string or an URI for ' + propName + ' in ' +
   *            componentName
   *          );
   *        }
   *      }
   *    },
   *    render: function() {...}
   *  });
   *
   * @internal
   */

  var ANONYMOUS = '<<anonymous>>';

  // Important!
  // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
  var ReactPropTypes = {
    array: createPrimitiveTypeChecker('array'),
    bool: createPrimitiveTypeChecker('boolean'),
    func: createPrimitiveTypeChecker('function'),
    number: createPrimitiveTypeChecker('number'),
    object: createPrimitiveTypeChecker('object'),
    string: createPrimitiveTypeChecker('string'),
    symbol: createPrimitiveTypeChecker('symbol'),

    any: createAnyTypeChecker(),
    arrayOf: createArrayOfTypeChecker,
    element: createElementTypeChecker(),
    elementType: createElementTypeTypeChecker(),
    instanceOf: createInstanceTypeChecker,
    node: createNodeChecker(),
    objectOf: createObjectOfTypeChecker,
    oneOf: createEnumTypeChecker,
    oneOfType: createUnionTypeChecker,
    shape: createShapeTypeChecker,
    exact: createStrictShapeTypeChecker,
  };

  /**
   * inlined Object.is polyfill to avoid requiring consumers ship their own
   * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
   */
  /*eslint-disable no-self-compare*/
  function is(x, y) {
    // SameValue algorithm
    if (x === y) {
      // Steps 1-5, 7-10
      // Steps 6.b-6.e: +0 != -0
      return x !== 0 || 1 / x === 1 / y;
    } else {
      // Step 6.a: NaN == NaN
      return x !== x && y !== y;
    }
  }
  /*eslint-enable no-self-compare*/

  /**
   * We use an Error-like object for backward compatibility as people may call
   * PropTypes directly and inspect their output. However, we don't use real
   * Errors anymore. We don't inspect their stack anyway, and creating them
   * is prohibitively expensive if they are created too often, such as what
   * happens in oneOfType() for any type before the one that matched.
   */
  function PropTypeError(message) {
    this.message = message;
    this.stack = '';
  }
  // Make `instanceof Error` still work for returned errors.
  PropTypeError.prototype = Error.prototype;

  function createChainableTypeChecker(validate) {
    if (process.env.NODE_ENV !== 'production') {
      var manualPropTypeCallCache = {};
      var manualPropTypeWarningCount = 0;
    }
    function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
      componentName = componentName || ANONYMOUS;
      propFullName = propFullName || propName;

      if (secret !== ReactPropTypesSecret_1) {
        if (throwOnDirectAccess) {
          // New behavior only for users of `prop-types` package
          var err = new Error(
            'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
            'Use `PropTypes.checkPropTypes()` to call them. ' +
            'Read more at http://fb.me/use-check-prop-types'
          );
          err.name = 'Invariant Violation';
          throw err;
        } else if (process.env.NODE_ENV !== 'production' && typeof console !== 'undefined') {
          // Old behavior for people using React.PropTypes
          var cacheKey = componentName + ':' + propName;
          if (
            !manualPropTypeCallCache[cacheKey] &&
            // Avoid spamming the console because they are often not actionable except for lib authors
            manualPropTypeWarningCount < 3
          ) {
            printWarning(
              'You are manually calling a React.PropTypes validation ' +
              'function for the `' + propFullName + '` prop on `' + componentName  + '`. This is deprecated ' +
              'and will throw in the standalone `prop-types` package. ' +
              'You may be seeing this warning due to a third-party PropTypes ' +
              'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.'
            );
            manualPropTypeCallCache[cacheKey] = true;
            manualPropTypeWarningCount++;
          }
        }
      }
      if (props[propName] == null) {
        if (isRequired) {
          if (props[propName] === null) {
            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
          }
          return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
        }
        return null;
      } else {
        return validate(props, propName, componentName, location, propFullName);
      }
    }

    var chainedCheckType = checkType.bind(null, false);
    chainedCheckType.isRequired = checkType.bind(null, true);

    return chainedCheckType;
  }

  function createPrimitiveTypeChecker(expectedType) {
    function validate(props, propName, componentName, location, propFullName, secret) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== expectedType) {
        // `propValue` being instance of, say, date/regexp, pass the 'object'
        // check, but we can offer a more precise error message here rather than
        // 'of type `object`'.
        var preciseType = getPreciseType(propValue);

        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createAnyTypeChecker() {
    return createChainableTypeChecker(emptyFunctionThatReturnsNull);
  }

  function createArrayOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
      }
      var propValue = props[propName];
      if (!Array.isArray(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
      }
      for (var i = 0; i < propValue.length; i++) {
        var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret_1);
        if (error instanceof Error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createElementTypeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      if (!isValidElement(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createElementTypeTypeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      if (!reactIs.isValidElementType(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement type.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createInstanceTypeChecker(expectedClass) {
    function validate(props, propName, componentName, location, propFullName) {
      if (!(props[propName] instanceof expectedClass)) {
        var expectedClassName = expectedClass.name || ANONYMOUS;
        var actualClassName = getClassName(props[propName]);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createEnumTypeChecker(expectedValues) {
    if (!Array.isArray(expectedValues)) {
      if (process.env.NODE_ENV !== 'production') {
        if (arguments.length > 1) {
          printWarning(
            'Invalid arguments supplied to oneOf, expected an array, got ' + arguments.length + ' arguments. ' +
            'A common mistake is to write oneOf(x, y, z) instead of oneOf([x, y, z]).'
          );
        } else {
          printWarning('Invalid argument supplied to oneOf, expected an array.');
        }
      }
      return emptyFunctionThatReturnsNull;
    }

    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      for (var i = 0; i < expectedValues.length; i++) {
        if (is(propValue, expectedValues[i])) {
          return null;
        }
      }

      var valuesString = JSON.stringify(expectedValues, function replacer(key, value) {
        var type = getPreciseType(value);
        if (type === 'symbol') {
          return String(value);
        }
        return value;
      });
      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + String(propValue) + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createObjectOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
      }
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
      }
      for (var key in propValue) {
        if (has(propValue, key)) {
          var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
          if (error instanceof Error) {
            return error;
          }
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createUnionTypeChecker(arrayOfTypeCheckers) {
    if (!Array.isArray(arrayOfTypeCheckers)) {
      process.env.NODE_ENV !== 'production' ? printWarning('Invalid argument supplied to oneOfType, expected an instance of array.') : void 0;
      return emptyFunctionThatReturnsNull;
    }

    for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
      var checker = arrayOfTypeCheckers[i];
      if (typeof checker !== 'function') {
        printWarning(
          'Invalid argument supplied to oneOfType. Expected an array of check functions, but ' +
          'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.'
        );
        return emptyFunctionThatReturnsNull;
      }
    }

    function validate(props, propName, componentName, location, propFullName) {
      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
        var checker = arrayOfTypeCheckers[i];
        if (checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret_1) == null) {
          return null;
        }
      }

      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createNodeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      if (!isNode(props[propName])) {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      for (var key in shapeTypes) {
        var checker = shapeTypes[key];
        if (!checker) {
          continue;
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
        if (error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createStrictShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      // We need to check all keys in case some are required but missing from
      // props.
      var allKeys = objectAssign({}, props[propName], shapeTypes);
      for (var key in allKeys) {
        var checker = shapeTypes[key];
        if (!checker) {
          return new PropTypeError(
            'Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' +
            '\nBad object: ' + JSON.stringify(props[propName], null, '  ') +
            '\nValid keys: ' +  JSON.stringify(Object.keys(shapeTypes), null, '  ')
          );
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
        if (error) {
          return error;
        }
      }
      return null;
    }

    return createChainableTypeChecker(validate);
  }

  function isNode(propValue) {
    switch (typeof propValue) {
      case 'number':
      case 'string':
      case 'undefined':
        return true;
      case 'boolean':
        return !propValue;
      case 'object':
        if (Array.isArray(propValue)) {
          return propValue.every(isNode);
        }
        if (propValue === null || isValidElement(propValue)) {
          return true;
        }

        var iteratorFn = getIteratorFn(propValue);
        if (iteratorFn) {
          var iterator = iteratorFn.call(propValue);
          var step;
          if (iteratorFn !== propValue.entries) {
            while (!(step = iterator.next()).done) {
              if (!isNode(step.value)) {
                return false;
              }
            }
          } else {
            // Iterator will provide entry [k,v] tuples rather than values.
            while (!(step = iterator.next()).done) {
              var entry = step.value;
              if (entry) {
                if (!isNode(entry[1])) {
                  return false;
                }
              }
            }
          }
        } else {
          return false;
        }

        return true;
      default:
        return false;
    }
  }

  function isSymbol(propType, propValue) {
    // Native Symbol.
    if (propType === 'symbol') {
      return true;
    }

    // falsy value can't be a Symbol
    if (!propValue) {
      return false;
    }

    // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
    if (propValue['@@toStringTag'] === 'Symbol') {
      return true;
    }

    // Fallback for non-spec compliant Symbols which are polyfilled.
    if (typeof Symbol === 'function' && propValue instanceof Symbol) {
      return true;
    }

    return false;
  }

  // Equivalent of `typeof` but with special handling for array and regexp.
  function getPropType(propValue) {
    var propType = typeof propValue;
    if (Array.isArray(propValue)) {
      return 'array';
    }
    if (propValue instanceof RegExp) {
      // Old webkits (at least until Android 4.0) return 'function' rather than
      // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
      // passes PropTypes.object.
      return 'object';
    }
    if (isSymbol(propType, propValue)) {
      return 'symbol';
    }
    return propType;
  }

  // This handles more types than `getPropType`. Only used for error messages.
  // See `createPrimitiveTypeChecker`.
  function getPreciseType(propValue) {
    if (typeof propValue === 'undefined' || propValue === null) {
      return '' + propValue;
    }
    var propType = getPropType(propValue);
    if (propType === 'object') {
      if (propValue instanceof Date) {
        return 'date';
      } else if (propValue instanceof RegExp) {
        return 'regexp';
      }
    }
    return propType;
  }

  // Returns a string that is postfixed to a warning about an invalid type.
  // For example, "undefined" or "of type array"
  function getPostfixForTypeWarning(value) {
    var type = getPreciseType(value);
    switch (type) {
      case 'array':
      case 'object':
        return 'an ' + type;
      case 'boolean':
      case 'date':
      case 'regexp':
        return 'a ' + type;
      default:
        return type;
    }
  }

  // Returns class name of the object, if any.
  function getClassName(propValue) {
    if (!propValue.constructor || !propValue.constructor.name) {
      return ANONYMOUS;
    }
    return propValue.constructor.name;
  }

  ReactPropTypes.checkPropTypes = checkPropTypes_1;
  ReactPropTypes.resetWarningCache = checkPropTypes_1.resetWarningCache;
  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};

function emptyFunction() {}
function emptyFunctionWithReset() {}
emptyFunctionWithReset.resetWarningCache = emptyFunction;

var factoryWithThrowingShims = function() {
  function shim(props, propName, componentName, location, propFullName, secret) {
    if (secret === ReactPropTypesSecret_1) {
      // It is still safe when called from React.
      return;
    }
    var err = new Error(
      'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
      'Use PropTypes.checkPropTypes() to call them. ' +
      'Read more at http://fb.me/use-check-prop-types'
    );
    err.name = 'Invariant Violation';
    throw err;
  }  shim.isRequired = shim;
  function getShim() {
    return shim;
  }  // Important!
  // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
  var ReactPropTypes = {
    array: shim,
    bool: shim,
    func: shim,
    number: shim,
    object: shim,
    string: shim,
    symbol: shim,

    any: shim,
    arrayOf: getShim,
    element: shim,
    elementType: shim,
    instanceOf: getShim,
    node: shim,
    objectOf: getShim,
    oneOf: getShim,
    oneOfType: getShim,
    shape: getShim,
    exact: getShim,

    checkPropTypes: emptyFunctionWithReset,
    resetWarningCache: emptyFunction
  };

  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};

var propTypes = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

if (process.env.NODE_ENV !== 'production') {
  var ReactIs = reactIs;

  // By explicitly using `prop-types` you are opting into new development behavior.
  // http://fb.me/prop-types-in-prod
  var throwOnDirectAccess = true;
  module.exports = factoryWithTypeCheckers(ReactIs.isElement, throwOnDirectAccess);
} else {
  // By explicitly using `prop-types` you are opting into new production behavior.
  // http://fb.me/prop-types-in-prod
  module.exports = factoryWithThrowingShims();
}
});

var css_248z$6 = "#speech.btn {\r\n  border: none;\r\n  padding: 0;\r\n  border-radius: 100%;\r\n  width: 35px;\r\n  height: 35px;\r\n  font-size: 1.5em;\r\n  color: #fff;\r\n  padding: 0;\r\n  margin: 0;\r\n  position: relative;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: center;\r\n  line-height: 50px;\r\n  text-align: center;\r\n  white-space: nowrap;\r\n  vertical-align: middle;\r\n  -ms-touch-action: manipulation;\r\n  touch-action: manipulation;\r\n  cursor: pointer;\r\n  -webkit-user-select: none;\r\n  -moz-user-select: none;\r\n  -ms-user-select: none;\r\n  user-select: none;\r\n  background-image: none;\r\n}\r\n\r\n.pulse-ring {\r\n  content: \"\";\r\n  width: 35px;\r\n  height: 35px;\r\n  border: 5px solid lightblue;\r\n  border-radius: 50%;\r\n  position: absolute;\r\n  display: none;\r\n  top: -5px;\r\n  left: -5px;\r\n  animation: pulsate infinite 2s;\r\n}\r\n\r\n@-webkit-keyframes pulsate {\r\n  0% {\r\n    -webkit-transform: scale(1, 1);\r\n    opacity: 1;\r\n  }\r\n  100% {\r\n    -webkit-transform: scale(1.2, 1.2);\r\n    opacity: 0;\r\n  }\r\n}\r\n";
styleInject(css_248z$6);

var recognition = window.webkitSpeechRecognition;
var speech = new recognition();
speech.continuous = true;
var VoiceFun = function VoiceFun(On, seton) {
  var $input = document.getElementById('Input');
  $input.focus();

  speech.onresult = function (e) {
    var current = e.resultIndex;
    var transcript = e.results[current][0].transcript;
    $input.value += transcript;
    $input.onkeyup();
  };

  seton(function (prev) {
    return !prev;
  });

  if (On) {
    document.querySelector('.pulse-ring').style.display = 'block';

    if (recognition) {
      speech.start();
    } else alert('Browser Not supported!!');
  } else {
    document.querySelector('.pulse-ring').style.display = 'none';
    speech.stop();
  }
};

function Voice(_ref) {
  var data = _ref.data,
      setdata = _ref.setdata,
      background = _ref.background,
      theme = _ref.theme,
      voice = _ref.voice,
      fun = _ref.fun,
      echoColor = _ref.echoColor;

  var _useState = React.useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      openMic = _useState2[0],
      setopen = _useState2[1];

  return /*#__PURE__*/React__default["default"].createElement("div", {
    style: voice ? null : {
      display: "none"
    },
    className: "Chat_Box_voice_to_word"
  }, /*#__PURE__*/React__default["default"].createElement("button", {
    style: {
      background: background
    },
    onClick: fun ? function () {
      return VoiceFun(openMic, setopen);
    } : function () {
      return OnMic(openMic, setopen, data, setdata);
    },
    id: "speech",
    className: "btn"
  }, /*#__PURE__*/React__default["default"].createElement(Microphone, {
    theme: theme === 'dark' ? "black" : "white",
    height: "15",
    width: "15"
  }), /*#__PURE__*/React__default["default"].createElement("div", {
    className: "pulse-ring",
    style: echoColor ? {
      border: "5px solid ".concat(echoColor),
      width: "22px",
      height: "22px",
      top: "0",
      left: "1px"
    } : null
  })));
}

var css_248z$5 = ".Picker_br > aside {\r\n  position: absolute;\r\n  display: none;\r\n  bottom: 0;\r\n  right: 5px;\r\n  z-index: 1;\r\n}\r\n.Picker_bl > aside {\r\n  position: absolute;\r\n  display: none;\r\n  bottom: 0;\r\n  left: 5px;\r\n  z-index: 1;\r\n}\r\n\r\n.Picker_container {\r\n  margin-left: 6px;\r\n  cursor: pointer;\r\n}\r\n.Chat_Box_Emoji_picker {\r\n  margin-right: 8px;\r\n}\r\n";
styleInject(css_248z$5);

function EmojiPicker(_ref) {
  var data = _ref.data,
      setdata = _ref.setdata,
      position = _ref.position,
      emoji = _ref.emoji;

  var _useState = React.useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      pick = _useState2[0],
      setpick = _useState2[1];

  var ChooseEmoji = function ChooseEmoji(event, emojiobj) {
    openEmoji(pick, setpick, position);
    setdata(_objectSpread2(_objectSpread2({}, data), {}, {
      Message: data.Message + (emojiobj === null || emojiobj === void 0 ? void 0 : emojiobj.emoji),
      emoji: emojiobj === null || emojiobj === void 0 ? void 0 : emojiobj.emoji
    }));
  };

  return /*#__PURE__*/React__default["default"].createElement("div", {
    style: emoji ? {
      display: "flex"
    } : {
      display: "none"
    },
    className: "Chat_Box_Emoji_picker"
  }, /*#__PURE__*/React__default["default"].createElement("div", {
    className: "Picker_container",
    onClick: function onClick() {
      return openEmoji(pick, setpick, position);
    }
  }, /*#__PURE__*/React__default["default"].createElement(Emoji, {
    theme: "#757272",
    height: "20",
    width: "20"
  })), /*#__PURE__*/React__default["default"].createElement("div", {
    className: position === 'br' ? 'Picker_br' : 'Picker_bl'
  }, /*#__PURE__*/React__default["default"].createElement(Picker__default["default"], {
    disableSearchBar: true,
    onEmojiClick: ChooseEmoji
  })));
}

var validate = function validate(data) {
  if (data.Message.trim() === "" && data.Media.audio === "" && data.Media.doc === "" && data.Media.Image === "") return false;else return true;
}; //debounce function

var debounce$1 = function debounce(fun, delay) {
  var time;
  return function () {
    if (time) {
      clearTimeout(time);
    }

    time = setTimeout(function () {
      fun();
    }, delay);
  };
};

var css_248z$4 = ".send_button {\r\n  box-shadow: 4px 4px 25px rgba(42, 139, 242, 0.15),\r\n    2px 2px 25px rgba(42, 139, 242, 0.05), 4px 6px 10px rgba(42, 139, 242, 0.15);\r\n  width: 4%;\r\n  height: 40px;\r\n  margin-left: 1%;\r\n  display: flex;\r\n  justify-content: center;\r\n  cursor: pointer;\r\n  align-items: center;\r\n  border-radius: 50%;\r\n}\r\n";
styleInject(css_248z$4);

function Send(_ref) {
  var data = _ref.data,
      setdata = _ref.setdata,
      Finish = _ref.Finish,
      background = _ref.background,
      theme = _ref.theme,
      delay = _ref.delay;

  var sendMessage = function sendMessage() {
    if (validate(data)) Finish(data);else return console.log(new Error('Invalidate Message!!'));
    document.getElementById('React_textarea').focus();
    setdata({
      Message: "",
      Media: {
        audio: "",
        doc: "",
        Image: ""
      },
      emoji: ""
    });
  };

  return /*#__PURE__*/React__default["default"].createElement("div", {
    style: {
      background: background
    },
    onClick: debounce$1(sendMessage, delay),
    className: "send_button"
  }, /*#__PURE__*/React__default["default"].createElement(SendSvg, {
    theme: theme === 'dark' ? "black" : "white",
    width: "20",
    height: "20"
  }));
}

var css_248z$3 = ".Chat_Box_Container {\r\n  display: flex;\r\n  border-radius: 30px;\r\n  width: 92%;\r\n  padding: 10px 1% 2px 1%;\r\n}\r\n.Chat_section {\r\n  width: 100%;\r\n  display: flex;\r\n  align-items: center;\r\n}\r\n\r\n.Special_components {\r\n  display: flex;\r\n  flex: 0;\r\n  align-items: center;\r\n  margin-top: -8px;\r\n}\r\n";
styleInject(css_248z$3);

function ChatBox(_ref) {
  var onDone = _ref.onDone,
      _ref$containerBackgro = _ref.containerBackground,
      containerBackground = _ref$containerBackgro === void 0 ? "#f5f0f075" : _ref$containerBackgro,
      _ref$mediaTypes = _ref.mediaTypes,
      mediaTypes = _ref$mediaTypes === void 0 ? ["Document", "Gallery", "Audio"] : _ref$mediaTypes,
      _ref$buttonBackground = _ref.buttonBackground,
      buttonBackground = _ref$buttonBackground === void 0 ? "linear-gradient(325.78deg, #2a8bf2 14.76%, #7cb8f7 87.3%)" : _ref$buttonBackground,
      _ref$Icontheme = _ref.Icontheme,
      Icontheme = _ref$Icontheme === void 0 ? "light" : _ref$Icontheme,
      _ref$EmojiPosition = _ref.EmojiPosition,
      EmojiPosition = _ref$EmojiPosition === void 0 ? 'br' : _ref$EmojiPosition,
      _ref$placeholder = _ref.placeholder,
      placeholder = _ref$placeholder === void 0 ? 'Enter Your message here' : _ref$placeholder,
      _ref$debouncedelay = _ref.debouncedelay,
      debouncedelay = _ref$debouncedelay === void 0 ? 2000 : _ref$debouncedelay,
      _ref$media = _ref.media,
      media = _ref$media === void 0 ? true : _ref$media,
      _ref$voice = _ref.voice,
      voice = _ref$voice === void 0 ? true : _ref$voice,
      _ref$emoji = _ref.emoji,
      emoji = _ref$emoji === void 0 ? true : _ref$emoji;

  // console.log(onDone)
  var _useState = React.useState({
    Message: "",
    Media: {
      audio: "",
      doc: "",
      Image: ""
    },
    emoji: ""
  }),
      _useState2 = _slicedToArray(_useState, 2),
      data = _useState2[0],
      setdata = _useState2[1]; // console.log(data)


  return /*#__PURE__*/React__default["default"].createElement("div", {
    className: "Chat_section"
  }, /*#__PURE__*/React__default["default"].createElement("section", {
    style: {
      background: containerBackground
    },
    className: "Chat_Box_Container"
  }, /*#__PURE__*/React__default["default"].createElement(Media, {
    data: data,
    setdata: setdata,
    media: media,
    Types: mediaTypes,
    background: buttonBackground,
    theme: Icontheme
  }), /*#__PURE__*/React__default["default"].createElement(Input$1, {
    media: media,
    data: data,
    setdata: setdata,
    placeholder: placeholder
  }), /*#__PURE__*/React__default["default"].createElement("div", {
    className: "Special_components"
  }, /*#__PURE__*/React__default["default"].createElement(EmojiPicker, {
    emoji: emoji,
    data: data,
    setdata: setdata,
    position: EmojiPosition
  }), /*#__PURE__*/React__default["default"].createElement(Voice, {
    voice: voice,
    data: data,
    setdata: setdata,
    background: buttonBackground,
    theme: Icontheme
  }))), /*#__PURE__*/React__default["default"].createElement(Send, {
    delay: debouncedelay,
    data: data,
    setdata: setdata,
    Finish: onDone,
    background: buttonBackground
  }));
}

ChatBox.propTypes = {
  onDone: propTypes.func,
  containerBackground: propTypes.string,
  mediaTypes: propTypes.array,
  Icontheme: propTypes.string,
  EmojiPosition: propTypes.string,
  placeholder: propTypes.string,
  debouncedelay: propTypes.number,
  media: propTypes.bool,
  voice: propTypes.bool
};

var getresults = function getresults(setdata, options, searchparam) {
  // console.log(document.getElementById('Input').value)
  options["params"][searchparam] = document.getElementById('Input').value.trim();
  axios__default["default"].request(options).then(function (res) {
    // console.log(res.data)
    setdata(res.data);
  })["catch"](function (e) {
    return console.log(e);
  });
};

var debounce = function debounce(fn, delay, set, options, searchParam) {
  var time;
  return function () {
    if (time) clearTimeout(time);
    time = setTimeout(function () {
      fn(set, options, searchParam);
    }, delay);
  };
};

var css_248z$2 = ".Input_container > input {\r\n  width: 97%;\r\n  font-family: Arial, Helvetica, sans-serif;\r\n  font-size: 1rem;\r\n  border: 0;\r\n}\r\n.Input_container {\r\n  flex: 2;\r\n}\r\n.Input_container > input:focus {\r\n  outline: 0;\r\n}\r\n";
styleInject(css_248z$2);

function Input(_ref) {
  var setresults = _ref.setresults,
      onDone = _ref.onDone,
      option = _ref.option,
      Searchparam = _ref.Searchparam,
      typingDelay = _ref.typingDelay;
  var inputRef = React.useRef();
  React.useEffect(function () {
    inputRef.current.onkeyup = debounce(getresults, typingDelay, setresults, option, Searchparam);

    document.getElementById('Search_event').onclick = function () {
      if (inputRef.current.value.trim() === "") return console.log(new Error("Invalid message!!"));
      onDone(inputRef.current.value);
      setresults([]);
    };

    inputRef.current.onfocus = function () {
      document.querySelector('.dummy_style').style.opacity = 1;
      document.querySelector('.dummy_style').style.width = "100%";
      document.querySelector('#Main_container').style.boxShadow = "1px 1px 2px gray";
    };

    inputRef.current.onblur = function () {
      document.querySelector('.dummy_style').style.opacity = 0;
      document.querySelector('.dummy_style').style.width = "0%";
      document.querySelector('#Main_container').style.boxShadow = "2px 2px 4px gray";
    };
  }, []);
  return /*#__PURE__*/React__default["default"].createElement("div", {
    className: "Input_container"
  }, /*#__PURE__*/React__default["default"].createElement("input", {
    ref: inputRef,
    id: "Input",
    type: "text",
    autoComplete: "off"
  }));
}

var css_248z$1 = ".Main_container {\r\n  width: 100%;\r\n}\r\n.Input_container_Main {\r\n  width: 100%;\r\n  position: relative;\r\n  background-color: white;\r\n  align-items: center;\r\n  border-radius: 200px;\r\n  box-shadow: 2px 2px 4px gray;\r\n  box-sizing: border-box;\r\n  padding: 5px 0px;\r\n}\r\n.Input_Specials {\r\n  display: flex;\r\n  align-items: center;\r\n}\r\n.dummy_style {\r\n  width: 100%;\r\n  height: 101%;\r\n  left: -2px;\r\n  transition: width 1s, opacity 1s;\r\n  width: 0px;\r\n  top: -2px;\r\n  opacity: 0;\r\n  z-index: -1;\r\n  border-radius: 200px;\r\n  position: absolute;\r\n}\r\n.Input_container-top {\r\n  display: flex;\r\n  justify-content: space-between;\r\n  align-items: center;\r\n  border-bottom: 1px solid gray;\r\n  margin: 0px 10px;\r\n}\r\n.Search_button {\r\n  cursor: pointer;\r\n  margin: 3px 0 0 0;\r\n}\r\n";
styleInject(css_248z$1);

var css_248z = ".Results_container {\r\n  width: 100%;\r\n}\r\n\r\n.Results_container > div {\r\n  cursor: pointer;\r\n  margin-left: 5px;\r\n}\r\n.Results_container > div > div {\r\n  padding: 2px;\r\n  font-family: Arial, Helvetica, sans-serif;\r\n  font-size: 0.9rem;\r\n}\r\n.Results_container > div :hover {\r\n  background: rgb(229, 226, 226);\r\n}\r\n";
styleInject(css_248z);

function Results(_ref) {
  var results = _ref.results,
      setresults = _ref.setresults,
      onDone = _ref.onDone,
      texthighlight = _ref.texthighlight;
  // console.log(results)
  React.useEffect(function () {
    var $main = document.querySelector('#Main_container');
    var $border = document.querySelector('.Input_container-top');
    var $dummy = document.querySelector('.dummy_style');

    if (results.length === 0) {
      $main.style.borderRadius = '200px';
      $dummy.style.top = "-2px";
      $border.style.border = 0;
      $dummy.style.borderRadius = '50px';
    } else {
      $dummy.style.borderRadius = '10px';
      $main.style.borderRadius = '10px';
      $dummy.style.top = "-4px";
      $border.style.borderBottom = "1px solid gray";
    }
  }, [results]);

  var Finish = function Finish(each) {
    onDone(each);
    document.getElementById('Input').value = each;
    setresults([]);
  };

  return /*#__PURE__*/React__default["default"].createElement("div", {
    className: "Results_container"
  }, results === null || results === void 0 ? void 0 : results.map(function (each, index) {
    return /*#__PURE__*/React__default["default"].createElement("div", {
      onClick: function onClick() {
        return Finish(each);
      },
      key: index
    }, /*#__PURE__*/React__default["default"].createElement("div", null, parse__default["default"](each.replace(document.getElementById('Input').value.trim(), function (text) {
      return texthighlight.toLowerCase() === "none" ? text : text.fontcolor("".concat(texthighlight.toLowerCase()));
    }))));
  }));
}

function Main(_ref) {
  var onDone = _ref.onDone,
      _ref$option = _ref.option,
      option = _ref$option === void 0 ? {
    method: 'GET',
    url: 'https://contextualwebsearch-websearch-v1.p.rapidapi.com/api/spelling/AutoComplete',
    params: {},
    headers: {
      'x-rapidapi-key': '8da286b0c3msh1d5e60f033d4aeap1b0e36jsn28b44375c3ba',
      'x-rapidapi-host': 'contextualwebsearch-websearch-v1.p.rapidapi.com'
    }
  } : _ref$option,
      _ref$searchParam = _ref.searchParam,
      searchParam = _ref$searchParam === void 0 ? "text" : _ref$searchParam,
      _ref$outerBorder = _ref.outerBorder,
      outerBorder = _ref$outerBorder === void 0 ? "red" : _ref$outerBorder,
      _ref$textHighlight = _ref.textHighlight,
      textHighlight = _ref$textHighlight === void 0 ? "red" : _ref$textHighlight,
      _ref$micPulseColor = _ref.micPulseColor,
      micPulseColor = _ref$micPulseColor === void 0 ? 'lightgray' : _ref$micPulseColor,
      _ref$typingDelay = _ref.typingDelay,
      typingDelay = _ref$typingDelay === void 0 ? 1000 : _ref$typingDelay;

  var _useState = React.useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      results = _useState2[0],
      setresults = _useState2[1];

  return /*#__PURE__*/React__default["default"].createElement("div", {
    className: "Main_container"
  }, /*#__PURE__*/React__default["default"].createElement("div", {
    className: "Input_container_Main",
    id: "Main_container"
  }, /*#__PURE__*/React__default["default"].createElement("div", {
    className: "Input_container-top"
  }, /*#__PURE__*/React__default["default"].createElement(Input, {
    typingDelay: typingDelay,
    option: option,
    Searchparam: searchParam,
    onDone: onDone,
    results: results,
    setresults: setresults
  }), /*#__PURE__*/React__default["default"].createElement("div", {
    style: outerBorder.toLowerCase() === "none" ? {
      display: "none"
    } : {
      border: "2px solid ".concat(outerBorder)
    },
    className: "dummy_style"
  }), /*#__PURE__*/React__default["default"].createElement("div", {
    className: "Input_Specials"
  }, /*#__PURE__*/React__default["default"].createElement(Voice, {
    echoColor: micPulseColor,
    fun: true,
    data: results,
    setdata: setresults,
    background: "none",
    theme: "dark",
    voice: true
  }), /*#__PURE__*/React__default["default"].createElement("div", {
    id: "Search_event",
    className: "Search_button"
  }, "  ", /*#__PURE__*/React__default["default"].createElement(Search, {
    width: "20",
    height: "18",
    theme: "black"
  })))), /*#__PURE__*/React__default["default"].createElement(Results, {
    texthighlight: textHighlight,
    onDone: onDone,
    results: results,
    setresults: setresults
  })));
}

Main.propTypes = {
  onDone: propTypes.func,
  option: propTypes.object,
  searchParam: propTypes.string,
  outerBorder: propTypes.string,
  textHighlight: propTypes.string,
  micPulseColor: propTypes.string,
  typingDelay: propTypes.number
};

exports.Autocomplete = Main;
exports.ChatBox = ChatBox;
